% SatNOGS COMMS Final Report
% Copyright (C) 2020, 2021, 2022, 2023, 2024 Libre Space Foundation
%
% This work is licensed under a
% Creative Commons Attribution-ShareAlike 4.0 International License.
%
% You should have received a copy of the license along with this
% work.  If not, see <http://creativecommons.org/licenses/by-sa/4.0/>.

% Linter settings
% chktex-file -2
% chktex-file 8
% chktex-file 18
% chktex-file 35
% chktex-file 13

\documentclass[english,title,a4paper]{report}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[english]{babel}
\usepackage{float}
\usepackage[hidelinks]{hyperref}
\usepackage[toc,acronyms,section,nopostdot,nonumberlist,section=section,numberedsection]{glossaries}
\usepackage[toc,page]{appendix}
\usepackage{graphicx}
\usepackage{titlesec}
\usepackage{fancyhdr}
\usepackage{lastpage}
\usepackage{amssymb}
\usepackage{textcomp,gensymb}
\usepackage{booktabs}
\usepackage{pifont}
\usepackage{verbatim}
\usepackage{rotating}
\usepackage{makecell}
\usepackage{multirow}
\usepackage{lipsum}
\usepackage{longtable,tabularx}
\usepackage{subcaption}
\usepackage{xcolor, soul}
\usepackage[absolute,overlay]{textpos}
% \usepackage[paper=portrait,pagesize]{typearea}


\usepackage{hyperref}
\hypersetup{
    colorlinks=true,
    linkcolor=black,
    filecolor=magenta,
    urlcolor=blue,
    citecolor=black,
}

\fancypagestyle{plain}{
  \fancyhf{}
  \fancyhead[R]{SatNOGS COMMS\\Final Report}
  \fancyhead[L]{\includegraphics[width=1.5cm]{diagrams/LSF_HD_Icon_Color.png}} %chktex-file 25
  % \fancyfoot[L]{Version \version}
  \fancyfoot[C]{\thepage{} of~\pageref{LastPage}}
  % \fancyfoot[R]{\copyright{} Libre Space Foundation}
  \renewcommand{\headrulewidth}{0.4pt}
  \renewcommand{\footrulewidth}{0.4pt}
}
\pagestyle{plain}
\setcounter{secnumdepth}{3}
\setcounter{tocdepth}{3}

\newcommand{\cmark}{\ding{51}}%
\newcommand{\xmark}{\ding{55}}%

\newcommand\TBD[1]{\textcolor{red}{#1}}

\input{include/version}

\makeglossaries{}

%% Acronyms
\input{glossaries/acronyms}

\title{Final Report \\\large{SatNOGS COMMS}}
\author{\includegraphics[scale=0.2]{diagrams/lsf-logo.png}}
% \date{Version \version}
\titleformat{\chapter}[hang]
{\normalfont\bfseries\Huge}{\thechapter.}{10pt}{}

\makeatletter
\renewcommand{\maketitle}{
    \begin{titlepage}
        \centering
        {\LARGE\@title\par}
        \vspace{2cm}
        {\@author\par}
        % Add a custom text box at the bottom left corner
        \begin{textblock*}{10cm} (1cm, 25cm) % Adjust width and position
            \small
            EUROPEAN SPACE AGENCY CONTRACT REPORT
            The work described in this report was done under ESA Contract.
            Responsibility for the contents resides in the author or organisation that
            prepared it.
        \end{textblock*}
    \end{titlepage}
}
\makeatother

\begin{document}

\hypersetup{pageanchor=false}
\maketitle
\hypersetup{pageanchor=true}
\tableofcontents

\chapter{Changelog}

\begin{tabular}{llp{6.5cm}}
    \toprule
    Version & Date          & Changes                                       \\ \midrule
    1.5.2   & Dec 18, 2024  & Initial release                               \\ \bottomrule
\end{tabular}

\newpage
\printglossary[type=\acronymtype]

\chapter{Scope}

This document outlines the major achievements of the SatNOGS COMMS activity in a concise manner, suitable for general public distribution.
In particular, the most important characteristics of the system are described in order to provide an overview of the achieved capabilities.
Additionally, results from tests and actual missions are presented to support the claimed TRL.

\chapter{System Description}

The SatNOGS-COMMS transceiver is a complete telecommunication solution suitable for nanosatellites.
The main components of the transceiver are depicted in \autoref{fig:system-blocks} while an actual assembled and fully operational board is presented in \autoref{fig:comms-pcb}.

\begin{figure}[H]
  \centering
  \includegraphics[keepaspectratio, width=1\textwidth]{diagrams/system-blocks.png}
  \caption{Main components of the SatNOGS-COMMS transceiver}\label{fig:system-blocks}
\end{figure}

\section{Radio Capabilities}

The SatNOGS-COMMS transceiver provides two half-duplex RF interfaces that can operate independently on the UHF and S-Band frequencies.
The tuning capabilities of the UHF interface are within the range [395--500] MHz for both TX and RX with a resolution of 100 Hz.
The S-Band interface can tune in the frequencies [2200--2290], [2400--2450] MHz for TX and [2025--2110], [2200--2290], [2400--2450] MHz for RX with a resolution of 1.5 Hz.

\begin{figure}[H]
  \centering
  \includegraphics[width=0.6\textwidth]{diagrams/comms-pcb.jpg}
  \caption{An assembled SatNOGS-COMMS board}\label{fig:comms-pcb}
\end{figure}

The radio of the SatNOGS-COMMS board is based on the AT86RF215~\cite{AT86RF215} \acrshort{ic} transceiver.
This \acrshort{ic} operates simultaneously on both UHF and 2.4 GHz \acrshort{ism} bands and supports a set of modulation and framing schemes including \acrshort{fsk}, \acrshort{bpsk} and \acrshort{qpsk}.
In addition, it provides an I/Q interface with a maximum sampling rate of 4 \acrshort{msps} and a variety of user-defined, low pass filters.
The SatNOGS-COMMS transceiver utilizes a \acrshort{dsp} co-processor and the I/Q interface to implement the specified \acrshort{ccsds} modulation and coding schemes that are not available by the modem of the AT86RF215 \acrshort{ic}.
Nevertheless, the integrated IEEE 802.15.4 hardware modem of the \acrshort{ic} is still available.
Additional information related to the RF front-end and radio architecture is available at the \autoref{section:rf}.

\section{Processing Units}
Depending on the application demands, the processing requirements of the transceiver are fulfilled by two different processing units, the main control unit and the \acrshort{dsp} co-processor. 
The main controller unit is responsible for the coordination and control of the entire board as well as for implementing the communication between the transceiver and other subsystems of the satellite.
The selected \acrshort{mcu} is the STM32H743~\cite{RM0433} providing a maximum frequency of 480 MHz, 2 MB of flash memory, 1 MB of RAM memory, \acrshort{ecc} capable memory regions and all the required \acrshort{io} interfaces.
The \acrshort{ecc} RAM regions can detect up to two error bits and can correct up to one error bit for each 32-bit word. 
The \acrshort{mcu} also provides two independent watchdogs for supervising the running software and handling software or hardware lockups.
For the \acrshort{dsp} related operations, the transceiver utilizes the ZYNQ-7020 \acrshort{fpga}\cite{zynq}.
This \acrshort{fpga} is responsible for handling time critical \acrshort{dsp} operations and communicating with the \acrshort{lvds} I/Q data interface of the AT86RF215 radio transceiver.
The \acrshort{fpga} is attached on the transceiver as a mezzanine daughter-board, giving an extra level of flexibility.
Missions may choose to select another \acrshort{fpga} family or totally emit the \acrshort{fpga} if not needed. 

\autoref{tab:modulations} provides the available modulation, framing and coding schemes, as well as the symbol rates that are supported by the SatNOGS-COMMS board.
The board provides a set of schemes that are handled by the baseband core of the AT86RF215 \acrshort{ic} and another utilizing the IQ interface of this \acrshort{ic} and the onboard \acrshort{fpga}.
The first set requires less power but exhibits several limitations (e.g. CC \acrshort{fec} available only for downlink, limited symbol rate configurations), whereas the latter, provides more flexibility and RF performance, at the cost of an increased power budget.
The achievable bitrate for every case depends on the \acrshort{fec} used and the bits per symbol of the corresponding modulation scheme.
Specifically, for the \acrshort{dsss} case, the achievable bitrate depends on the selected spreading factor.

  \begin{table*}[t]
  \captionof{table}{Available modulation, framing and coding schemes}\label{tab:modulations}
    \resizebox{\textwidth}{!}{%
      \centering
      \begin{tabular}{|c|c|c|c|c|c|c|}
        \hline
        \multicolumn{7}{|c|}{\textbf{Baseband Modem mode}} \\ \hline
        \textbf{Modulation} & \textbf{Framing} & \textbf{\begin{tabular}[c]{@{}c@{}}Line \\ Coding\end{tabular}} & \textbf{Whitening} & \textbf{\begin{tabular}[c]{@{}c@{}}Symbol \\ Rate\\ (ksps)\end{tabular}} & \textbf{FEC} & \textbf{\begin{tabular}[c]{@{}c@{}}Modulation\\  index\end{tabular}} \\ \hline
        \multirow{2}{*}{FSK/MSK} & IEEE 802.15.4 & --- & \begin{tabular}[c]{@{}c@{}}Off\\ IEEE 802.15.4\end{tabular} & \begin{tabular}[c]{@{}c@{}}50, 100, 150,\\ 200, 300, 400\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ RS (223,255)\\ CC R=1/2\\ CC R=1/2 + RS\end{tabular} & \begin{tabular}[c]{@{}c@{}}0.375, 0.5, 0.75,\\  1, 1.25, 1.5,\\  1.75, 2\end{tabular} \\ \cline{2-7}
                            & CCSDS & \begin{tabular}[c]{@{}c@{}}Off\\ NRZ-M\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}50, 100, 150,\\ 200, 300, 400\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ RS (223,255)\\ CC R=1/2\\ CC R=1/2 + RS\end{tabular} & \begin{tabular}[c]{@{}c@{}}0.375, 0.5, 0.75, 1, \\ 1.25, 1.5, 1.75, 2\end{tabular} \\ \hline
        O-QPSK DSSS & IEEE 802.15.4 & --- & \begin{tabular}[c]{@{}c@{}}Off\\ IEEE 802.15.4\end{tabular} & \begin{tabular}[c]{@{}c@{}}100, 200, 1000, \\ 2000\end{tabular} & --- & --- \\ \hline
        \multicolumn{7}{|c|}{\textbf{IQ Mode (DSP on FPGA)}} \\ \hline
        FSK/MSK & \begin{tabular}[c]{@{}c@{}}IEEE 802.15.4\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ NRZ-M\\ SP-L\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ IEEE 802.15.4\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}4.8, 9.6, 19.2, 20, 40, 50,\\ 80,100, 125, 150, 200,\\  250, 300, 400, 500,\\ 600, 800, 1000, 1200,\\  1400, 1800, 2000\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ RS (223, 255)\\ CC R=1/2\\ CC R=1/2 + RS\end{tabular} & \begin{tabular}[c]{@{}c@{}}0.375, 0.5, 0.75, 1, \\ 1.25, 1.5, 1.75, 2\end{tabular} \\ \hline
        BPSK & \begin{tabular}[c]{@{}c@{}}IEEE 802.15.4\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ NRZ-M\\ SP-L\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ IEEE 802.15.4\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}4.8, 9.6, 19.2, 20, 40, 50,\\ 80,100, 125, 150, 200,\\  250, 300, 400, 500,\\ 600, 800, 1000, 1200,\\  1400, 1800, 2000\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ RS (223, 255)\\ CC R=1/2\\ CC R=1/2 + RS\end{tabular} & $\pi$, $\frac{\pi}{2}$ \\ \hline
        QPSK & \begin{tabular}[c]{@{}c@{}}IEEE 802.15.4\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ NRZ-M\\ SP-L\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ IEEE 802.15.4\\ CCSDS\end{tabular} & \begin{tabular}[c]{@{}c@{}}4.8, 9.6, 19.2, 20, 40, 50,\\ 80,100, 125, 150, 200,\\  250, 300, 400, 500,\\ 600, 800, 1000, 1200,\\  1400, 1800, 2000\end{tabular} & \begin{tabular}[c]{@{}c@{}}Off\\ RS (223, 255)\\ CC R=1/2\\ CC R=1/2 + RS\end{tabular} & --- \\ \hline
      \end{tabular}
    }
  \end{table*}

The SatNOGS-COMMS transceiver utilizes a pair of SAMTEC ESQ-126–39–G-D connectors (in a PC/104 configuration) for the main bus interconnection with other subsystems of the satellite.
On the PC/104 bus, several communication peripherals are available, including a high speed SPI interface up to 8 Mbits/sec, an I\textsuperscript{2}C interface, a CAN 2.0 and a CAN-FD interface. 
An RGMII interface is provided on a separate connector as well.

The transceiver is equipped with a versatile power management system, that powers and monitors all the subsystems of the board, while protecting the spacecraft and the transceiver from over-current events.
The power management system allows for a quite wide range of input voltage starting from 5V up to 30V, simplifying the integration process of the transceiver in nanosatellite applications.
It provides current and voltage monitors on all the different major power rails (\acrshort{fpga}, digital components, analog components) as well temperature information and abnormal events (over-current, over-voltage).
It also provides enough control, so several components like the \acrshort{fpga}, the RF mixer, or the radio transceiver can be powered on demand to reduce the power consumption.

The transceiver also provides an onboard storage unit utilizing an \acrshort{emmc} memory module capable of covering the needs for store and forward functionality, experiment data storage, firmware upgrade and multiple \acrshort{fpga} firmware files for adaptive operation.
Capacity can vary, starting from 512 MB up to 16 GB upon customer request.

In addition, the SatNOGS-COMMS provides an antenna deployment interface that can be used to instruct and detect antenna deployment for each of the RF interfaces.
Based on current market antenna solutions, antenna deployment is either handled by the antenna subsystem itself via an I\textsuperscript{2}C interface or it is left for the integrator to implement (for example thermal knives).
For solutions having an antenna controller like GOMSpace NanoCom Ant-6f, Endurosat UHF Antenna III, and ISISPACE CubeSat Antenna  System for 1U/3U, the I\textsuperscript{2}C of the PC/104 bus can be used.
For antenna solutions without a controller, like NanoAvionics UHF Antenna System, the SatNOGS-COMMS transceiver provides a dedicated antenna deployment connector with activation and detection \acrshort{io} signal lines that can be used by any custom deployment controller.


\section{RF front-end}\label{section:rf}

\begin{figure}[H]
  \centering
  \includegraphics[width=1\textwidth]{diagrams/frontend-architectrure.pdf}
  \caption{RF front-end overview}\label{fig:front-end-architecture}
\end{figure}

The RF front-end architecture of the transceiver is presented in \autoref{fig:front-end-architecture}.
To achieve concurrent usage of both the UHF and S-Band interfaces, SatNOGS-COMMS has a separate RF front-end for each band.
Each RF interface has a similar design with a set of selectable filters for the reception path, RF switches and amplification stages and a dedicated \acrshort{pa} for the transmission path.
The band-pass filters can be selected on demand and can be either narrow or wide.
Narrow band-pass filters have a bandwidth of 10 MHz for both interfaces,
whereas the wide-band have a bandwidth of 100 MHz for the UHF and 400 MHz for the S-Band respectively.
The narrow filter path is mostly suitable for normal operation, receiving and decoding frames originating from ground station transmissions at the coordinated frequency.
On the other hand, the wide filter path can be used for spectrum sensing and monitoring or cognitive radio applications. 
Special attention has been given so that the characteristics of the narrow filters can change easily upon customer request, during fabrication, to better match the mission requirements.

\begin{figure}[H]
  \centering
  \includegraphics[width=\textwidth]{diagrams/uhf-radio.pdf}
  \caption{UHF RF front-end}\label{fig:uhf-radio}
\end{figure}

Due to the limited tuning frequency range of the AT86RF215 \acrshort{ic} in the S-band, the SatNOGS-COMMS transceiver makes use of an RF mixer (Qorvo RFFC5071~\cite{RFFC5071}) to increase its tuning capabilities.
The RF mixer is responsible to either down- or up-convert the [2025--2110], [2200--2290] MHz frequency bands that are not covered by the tuning capabilities of the AT86RF215, to those that are supported ([2400--2483.5] MHz).
On the UHF band there is no need for an RF mixer, since the AT86RF215 supports the entire [395-500] MHz spectrum region.
The S-band front-end is implemented with a goal of a low noise figure in the RX chain, by using a series of band pass filters and \acrshortpl{lna}
The goal is to maximize the selectivity without limiting the available dynamic range of the receiver and also prevent saturation, that will lead to inter-modulation products in the presence of strong out-of-band signals.
\autoref{fig:uhf-radio} and~\ref{fig:s-band-radio} present each RF interface in more detail.

\begin{figure}[H]
  \centering
  \includegraphics[width=\textwidth]{diagrams/s-band-radio.pdf}
  \caption{S-Band RF front-end}\label{fig:s-band-radio}
\end{figure}

As mentioned before, the SatNOGS-COMMS transceiver is suitable for \acrshort{leo} missions.
The design of the RF front-end takes into consideration a typical mission of an altitude of 600 km.
The path loss introduced defines the overall design for both the TX and RX chains in order for the transceiver to provide reliable downlink and uplink communication, while at the same time, it conforms with all the regulations for spectrum usage.
At AT86RF215 transceiver output power is limited to 14 dBm which is of course not enough for the requirements of a \acrshort{leo} mission.
Therefore both RF interfaces are using a dedicated \acrshort{pa}.
The UHF interface utilizes the TQP7M9106~\cite{TQP7M9106} \acrshort{pa}, which delivers 23 dB of gain.
However, due to some harmonics of the AT86RF215 transceiver and in order to conform with the SFCG 21--2R5~\cite{SFCG-21-2R5} specification for low data rate transmissions, a low pass filter with a stop band at 512 MHz is used.
The S-band interface follows a similar approach, using the SKY66292--11~\cite{SKY66292-11} \acrshort{pa} contributing with 34 dBm gain.
Likewise the UHF interface, the output signal is low pass filtered at 2250 MHz to suppress the amplified harmonics of the AT86RF215 that violate the SFCG 21--2R5~\cite{SFCG-21-2R5} specification.
A notable difference is a filtering stage prior to the \acrshort{pa}.
These band pass filters are used to attenuate the mixing artifacts so the conformance with SFCG 21--2R5~\cite{SFCG-21-2R5} is not violated.

To compensate for the path loss impairment on the RX paths, the transceiver incorporates a first order analog \acrshort{agc} mechanism.
This mechanism consists of a fixed gain \acrshort{lna} followed by a \acrshort{vga}.
The \acrshort{vga} gain control is performed for both interfaces automatically using the AD8318\cite{AD8318} logarithmic power detector.
There is also the option for the control software to set the \acrshort{vga} gain to a specific level.
Again, the S-band RX path is noticeably more complex, due to the path loss of the S-band which is greater than the UHF counterpart, but also due to the signal passing through the RF mixer, which is attenuated by a factor of -8.5 dB.
This loss is compensated with the addition of an extra \acrshort{lna} before the \acrshort{vga}.
The placement of the second \acrshort{lna} before the mixing process and after filtering is essential for the noise figure of the overall receiver design.

\section{Software}
The firmware of the STM32H743~\cite{RM0433} \acrshort{mcu} is responsible for interfacing with the board subsystems, gathering telemetry data, analyzing them and take the necessary actions for the well-being of the SatNOGS-COMMS transceiver.

The board is shipped with a reference firmware that utilizes the Zephyr-RTOS\cite{zephyros} 3.6.0 operating system, configured with static memory usage for all the internal functionality (queues, semaphores, stacks, etc).
However, in order to increase flexibility, the software is designed in a platform-independent way, providing an abstract control library called libsatnogs-comms\cite{libsatnogs-comms-repo}.
The library is written in C++ and provides an \acrshort{api} that exposes the entire functionality of the board.
Exploiting C++ polymorphism, methods that are platform specific (for example message queues, peripheral access) are exposed as pure virtual methods, requiring from the user to provide an implementation.
With this approach, users are not obliged to use the Zephyr-RTOS and can select another \acrshort{rtos} of choice.
One of the major drawbacks of C++ is that most of the \acrshort{stl} classes, use dynamically allocated memory, and therefore they cannot be used.
For this reason, the libsatnogs-comms takes advantage of the etlcpp\cite{etlcpp} library.
This header-only library provides most of the \acrshort{stl} functionality, but using a static memory model providing deterministic operation.

The libsatnogs-comms integrates also \acrshort{tmtc} capabilities using the \acrshort{osdlp}~\cite{osdlp-driver} library.
This software package implements the \acrshort{ccsds} Space Packet~\cite{CCSDS-132.0-B-2} and the \acrshort{ccsds} Data Link protocol for TM~\cite{CCSDS-133.0-B-1} and TC~\cite{CCSDS-232.0-B-3} respectively.
This library is implemented in a platform-independent fashion, therefore the same implementation is used on board the transceiver and at the ground station.
The \acrshort{osdlp} library uses a text-based descriptive language to define an arbitrary set of telecommands that the spacecraft supports and their corresponding responses.
These commands can be assigned into different \acrshort{ccsds} Space Packet virtual channels according to their priority and/or their purpose.
The SatNOGS-COMMS serves telecommands using a priority-scheduling algorithm based on the virtual channel number.
Virtual channels with lower numbers have higher priority and they are handled before the commands originating from higher virtual channels.
The same priority mechanism holds for the ground station too.

\section{Ground Segment Architecture}

\begin{figure}[H]
  \centering
  \includegraphics[width=0.5\textwidth]{diagrams/ground-segment-services.pdf}
  \caption{Ground Segment Subsystems}\label{fig:gs-services}
\end{figure}

The Ground Segment is a set of independent subsystems which interact to provide telemetry and telecommand services.
Figure~\ref{fig:gs-services} shows a diagram of these subsystems.
The \acrshort{satnogs} Ground Station comprises of the \acrshort{sdr} device, the \acrshort{satnogs} Radio and the \acrshort{satnogs} Client that is the controlling software.
A gRPC\cite{grpc} interface is used for the communication of the client and the radio to provide high-performance \acrshort{rpc} and bidirectional streaming.
The client pulls jobs (called \textit{Observations}) periodically from the \acrshort{satnogs} Network through a REST \acrshort{api} that the network provides.
These jobs reserve the time of the ground station for operations and are scheduled based on operator's selection and algorithms which calculate spacecraft passes.

There are two modes of operation for receiving telemetry; non real-time and real-time.
On non real-time mode, the client packs all telemetry data along with any other information and metadata of the Observation within an \acrshort{hdf5} file, and sends them directly to the SatNOGS DB through a REST \acrshort{api}.
On real-time mode, the client opens a \acrshort{grpc} connection with the \acrshort{satnogs} Yamcs~\cite{satnogs-comms-yamcs-repo} server.
The Yamcs server is a fully-featured mission control framework which is properly customized to meet the requirements of the operator. It receives the telemetry, processes it, stores it and makes it available to any user interface through its own \acrshort{api}.
Once the telemetry reaches Yamcs and is processed, it is then forwarded to the SatNOGS DB for archival and visualization purposes.

When operating in telecommand mode, a similar \acrshort{grpc} connection is also established between the client and Yamcs.
Again, Yamcs is customized to support the operators requested commands.
Since the connection is initiated by the client, handover from ground station to ground station is controlled by the SatNOGS Network based on calculated scheduling time-slots.
Further down the pipeline, telemetry data reaching the SatNOGS DB are processed by telemetry decoders and stored in an InfluxDB time series database.
The Yamcs telemetry and telecommand interfaces are depicted in \autoref{fig:yamcs-tlm} and \autoref{fig:yamcs-tlc}, respectively.

\begin{figure}[H]
  \centering
  \includegraphics[width=1.0\textwidth]{diagrams/yamc-xtce-tlm.png}
  \caption{Yamcs Telemetry Interface}\label{fig:yamcs-tlm}
\end{figure}

\begin{figure}[H]
  \centering
  \includegraphics[width=1.0\textwidth]{diagrams/yamcs-xtce-tlc.png}
  \caption{Yamcs Telecommand Interface}\label{fig:yamcs-tlc}
\end{figure}

A Grafana instance is then used to visualize this data.
Grafana Dashboards are developed and customized based on satellite operator's requirements.

The ground segment uses the \acrshort{sdr} technology to perform the \acrshort{dsp} tasks.
The software runs on any general purpose CPU using the GNU Radio\cite{gnuradio} as the base platform.
On top of GNU Radio, several modules are used to extend the basic functionality of the platform.
The overall architecture is depicted in Figure~\ref{fig:gs-dsp}.

The gr-soapy~\cite{gr-soapy} is a GNU Radio that wraps the SoapySDR~\cite{soapysdr} library.
This module provides a unified and vendor-neutral way to access and configure a wide range of different \acrshort{sdr} devices.
It also increases the flexibility of the ground station and allows a more robust and unified implementation of the \acrshort{dsp} software.
Starting from GNU Radio 3.10, the gr-soapy modules have been integrated into the main codebase of the GNU Radio.

For the processing of the digital I/Q samples, the gr-satnogs~\cite{gr-satnogs} GNU Radio module is used.
The gr-satnogs is responsible for common \acrshort{dsp} tasks vital for satellite communications.
During reception, it re-samples the received I/Q stream.
This is done for two main reasons.
The first one is that different \acrshort{sdr} front-ends have different sampling rate tune-ability capabilities.
The second reason has to do with the computational resources required for the \acrshort{dsp} tasks.
By properly re-sampling the signal to lower sampling rates, \acrshort{dsp} tasks that follow will require less computational resources.
This is an approach already tested in the SatNOGS Network with great success, allowing the ground station to operate even in \acrshort{sbc}, like the Raspberry Pi.
This gives a great advantage on the ground station, in terms of flexibility, acquisition and maintenance cost.
After re-sampling, gr-satnogs performs Doppler frequency correction.
Because the ground station should be able to operate with both suppressed and residual carrier modulation schemes, the Doppler frequency offset is mainly corrected using the orbital information of the satellite provided by its \acrshort{tle}.
However, after some filtering, the reception processing chain, tries to compensate any remaining frequency offset and equalize the signal amplitude to a reference level, in order to maximize the performance of the demodulator.
Based on the transmitter characteristics, the ground station utilizes one of the available modulation, coding and framing schemes provided by gr-satnogs, in order to demodulate and decode the received frames.
In addition, the gr-satnogs module provides a set of transceivers implementing the \acrshort{ccsds} recommendations for telemetry and telecommand synchronization and channel coding.
The implementation follows the specifications for Category A spacecrafts, described in the \acrshort{ccsds} blue books\cite{CCSDS-131.0-B-4,CCSDS-231.0-B-3,CCSDS-401.0-B-32}.

\begin{figure}[H]
  \centering
  \includegraphics[width=\textwidth]{diagrams/gs-dsp.pdf}
  \caption{\acrshort{dsp} software operations at the ground segment}\label{fig:gs-dsp}
\end{figure}

During transmission, the ground station uses the corresponding processing blocks provided by gr-satnogs in order to construct the digital signal.
Before propagating the samples to the \acrshort{sdr} front-end, the ground station inserts properly a frequency shift that will compensate the shift due to the Doppler as it will be observed from the spacecraft perspective.
This greatly eliminates the complexity of the receiver at the space segment.

\chapter{Test and Mission Results}

During the course of this activity, the developed system was subjected to various testing campaigns.
In particular, the system completed in-house performance assessment tests, but also environmental (vibration and TVAC) and EMC tests.
Additionally, the SatNOGS COMMS board was provided the opportunity to verify some of its functionalities in-orbit abort the Curium-1 mission.

\section{Performance Tests}

\subsection{RF Transmission}

The spurious emissions along with the spectrum mask of an RF transmission consitute key characteristics of any communications system.
In this regard, the peformance of the UHF and S-band radios onboard SatNOGS COMMS was evaluated.
The results for a specific power, modulation, and symbol rate are presented in \autoref{fig:tc-43-spurious}, \autoref{fig:tc-43-mask}, \autoref{fig:tc-44-spurious}, and \autoref{fig:tc-44-mask}.

\begin{figure}[H]
      \centering
      \includegraphics[keepaspectratio, width=0.8\textwidth]{diagrams/test-camp-2/tc-43-spurious.png}
      \caption{UHF spurious emissions}\label{fig:tc-43-spurious}
    \end{figure}

    \begin{figure}[H]
      \centering
      \includegraphics[keepaspectratio, width=0.8\textwidth]{diagrams/test-camp-2/tc-43-mask.png}
      \caption{UHF spectrum mask for FSK--2, m = 1, TX power = +31 dBm, symbol rate = 50 kHz}\label{fig:tc-43-mask}
    \end{figure}

\begin{figure}[H]
      \centering
      \includegraphics[keepaspectratio, width=0.8\textwidth]{diagrams/test-camp-3/tc-44-spurious.png}
      \caption{S Band spurious emissions}\label{fig:tc-44-spurious}
    \end{figure}

    \begin{figure}[H]
      \centering
      \includegraphics[keepaspectratio, width=0.8\textwidth]{diagrams/test-camp-3/tc-44-mask.png}
      \caption{S Band spectrum mask for FSK--2, m = 0.5, TX power = +33 dBm, 400 kHz symbol rate }\label{fig:tc-44-mask}
    \end{figure}

\subsection{RF Reception}

Besides a clean transmission spectrum, a satellite communications system must also feature a robust reception chain.
To this end, the ability of SatNOGS COMMS to demodulate and decode low power signals was investigated.
In particular, it was tested whether the system can demodulate and decode signals originating from a GS with a BER at most 3 dB worst than the BER curves or tables provided by CCSDS 130.1-G-2 and CCSDS 230.1-G-2

\begin{figure}[H]
    \centering
    \includegraphics[width=1\linewidth]{diagrams/uhf-ber.png}
    \caption{UHF Frame success rate for various signal levels}\label{fig:uhf-ber.png}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=1\linewidth]{diagrams/sband-ber.png}
    \caption{S-Band Frame success rate for various signal levels}\label{fig:sband-ber.png}
\end{figure}

Additionally, the BER performance of the system was tested.
In particular, the test focused on the carrier tracking capabilities for the maximum frequency offset induced by the Doppler shift.
The test results are presented in \autoref{fig:uhf-fsk-50k-offset-performance}, \autoref{fig:uhf-msk-50k-offset-perfromance}, \autoref{fig:sband-msk-100k-offset-performance}, \autoref{fig:sband-msk-200k-offset-performance}, and \autoref{fig:sband-msk-400k-offset-performance}.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/uhf-fsk-50k-offset-performance.png}
    \caption{Frame success rate for UHF FSK-2 at 50 kbps}\label{fig:uhf-fsk-50k-offset-performance}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/uhf-msk-50k-offset-perfromance.png}
    \caption{Frame success rate for UHF MSK at 50 kbps}\label{fig:uhf-msk-50k-offset-perfromance}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/sband-msk-100k-offset-performance.png}
    \caption{Frame success rate for S-Band MSK at 100 kbps}\label{fig:sband-msk-100k-offset-performance}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/sband-msk-200k-offset-performance.png}
    \caption{Frame success rate for S-Band MSK at 200 kbps}\label{fig:sband-msk-200k-offset-performance}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/sband-msk-400k-offset-performance.png}
    \caption{Frame success rate for S-Band MSK at 400 kbps}\label{fig:sband-msk-400k-offset-performance}
\end{figure}

\subsection{Power}
The power consumption of the board was measured for various operational states.
The results are presented in \autoref{tab:v03_power_measurements}.

\begin{table}[H]
      \centering
    \begin{tabular}{|l|c|c|l|}
    \hline
    State no. & \begin{tabular}[c]{@{}c@{}}Avg Current\\ {[}mA{]}\end{tabular} & \begin{tabular}[c]{@{}c@{}}Peak Current\\ {[}mA{]}\end{tabular} & State Description                    \\ \hline % chktex 9
    State 1   & 67                                                             & NA                                                              & MCU peripherals initialized          \\ \hline
    State 2   & 57                                                             & NA                                                              & State 1 + eMMC initialized           \\ \hline
    State 3   & NA                                                             & 91                                                              & State 2 + eMMC write                 \\ \hline
    State 4   & NA                                                             & 91                                                              & State 2 + eMMC read                  \\ \hline
    State 5   & 143                                                            & NA                                                              & State 2 + FPGA on                    \\ \hline
    State 6   & 203                                                            & NA                                                              & State 2 + FPGA running petalinux     \\ \hline
    State 7   & 230                                                            & NA                                                              & State 2 + FPGA stress petalinux      \\ \hline
    State 8   & 74                                                             & NA                                                              & State 1 + RF open                    \\ \hline
    State 9   & 71                                                             & NA                                                              & State 8 + init AT86                  \\ \hline
    State 10  & 370                                                            & 641                                                             & State 9 + full power TX UHF baseband \\ \hline
    State 11  & 247                                                            & NA                                                              & State 9 + RX UHF                     \\ \hline
    State 12  & 185                                                            & NA                                                              & State 9 + RX UHF                     \\ \hline
    State 13  & 250                                                            & NA                                                              & State 9 + RX UHF                     \\ \hline
    State 14  & NA                                                             & NA                                                              & State 9 + RX UHF                     \\ \hline
    State 15  & 467                                                            & 718                                                             & State 9 + full power TX S baseband    \\ \hline
    State 16  & 303                                                            & NA                                                              & State 9 + RX S                       \\ \hline
    State 17  & 267                                                            & NA                                                              & State 9 + RX S                       \\ \hline
    State 18  & 305                                                            & NA                                                              & State 9 + RX S                       \\ \hline
    State 19  & 245                                                            & NA                                                              & State 9 + RX S                       \\ \hline
    State 20  & 574                                                            & 750                                                             & State 15 + FPGA running petalinux    \\ \hline
    State 21  & 602                                                            & 773                                                             & State 15 + FPGA stress petalinux     \\ \hline
    \end{tabular}
    \caption{Current consumption in various operational states}\label{tab:v03_power_measurements}
\end{table}

\section{Environmental Tests}

\subsection{TVAC}

A total of 5 Type-K thermocouples were used to measure DUT temperature, these were insulated from the DUT with a layer of Kapton and covered in a layer of Kapton.
The positions of the thermocouples are listed in \autoref{table:k-type-tp}.
\begin{table}[!ht]
    \centering
    \begin{tabular}{ll}
    \toprule
        Test point & Description \\ \midrule
        TP-1 & UHF PA in PCB \\ \midrule
        TP-2 & Middle of EMI Shield \\ \midrule
        TP-3 & FPGA in EMI Shield \\ \midrule
        TP-4 & PC104 FlatSat \\ \midrule
        TP-5 & Control probe \\ \bottomrule
    \end{tabular}
    \caption{Thermocouples placement}\label{table:k-type-tp}
\end{table}

The thermal vacuum test was conducted for one full cycle and then a half cycle containing only the high temperature limit.
The reasoning behind the small number of test cycles lies in the depletion of the cooling fluid and the inadequate time to refill it during the time for which the test facility had been booked.
At the hot and cold plateus, a stress test with continuous UHF transmission was conducted.

\begin{figure}[H]
  \centering
  \includegraphics[width=1\textwidth]{diagrams/tvac-measurements.png}
  \caption{TVAC Cycling}\label{fig:tvac-measurements}
\end{figure}

\subsection{Vibration test}

To ensure that the SatNOGS COMMS hardware can sustain the high vibrations encountered during a rocket launch, it was subjected to vibrational testing.
The PCB was tested at the qualification levels specified in the ECSS-E-ST-10--03C with a resonance survey profile, a sine vibration profile and a quasi static shock profile, and a random vibration profile.

The lowest resonance frequencies of the SatNOGS COMMS are summarised in the following table (accelerometer sensor in the \acrshort{dut}):
\begin{table}[!ht]
    \centering
    \begin{tabular}{llllll}
    \toprule
        Sensor &  & Pre Survey &  & Post Survey &  \\ \midrule
         &  & Freq. (Hz) & Ampl.\ (g) & Freq. (Hz) & Ampl.\ (g) \\ \midrule
        X & Resonance 1 & 1.09k & 3.43 & 1.09k & 3.41 \\
         & Resonance 2 & 1.13k & 3.54 & 1.13k & 3.66 \\
         & Resonance 3 & 1.30k & 8.31 & 1.30k & 8.69 \\ \bottomrule
        Y & Resonance 1 & 1.10k & 2.81 & 1.10k & 2.68 \\
         & Resonance 2 & 1.14k & 2.79 & 1.14k & 2.84 \\
         & Resonance 3 & 1.27k & 3.35 & 1.27k & 3.18 \\
         & Resonance 4 & 1.39k & 13.3 & 1.42k & 9.23 \\
         & Resonance 5 & 1.46k & 5.75 & N/A & N/A \\ \bottomrule
        Z & Resonance 1 & 1.07k & 7.62 & 1.07k & 10.1 \\
         & Resonance 2 & 1.17k & 179m & 1.17k & 161m \\
         & Resonance 3 & 1.33k & 5.60 & 1.33k & 5.73 \\ \midrule
    \end{tabular}
    \caption{Resonance Frequencies}\label{table:vib-results}
\end{table}

After visual inspection in each axis tests there were no signs of damage.
More pictures can be found \href{https://cloud.libre.space/s/KeqsBpEyfSMjnQQ}{here}.
Additionally, plot results can be found \href{https://cloud.libre.space/s/yen62QiJwqbf2ZY}{here}.

\section{EMC Tests}

As is the case with any satellite component, electromagnetic compatibility with the operational environment must be ensured.
This includes a confirmation that the conducted and radiated emissions from the board are not violating some standardized limits, but also that the board is not susceptible to conducted and radiated interference.
The EMC test campaign for the SatNOGS COMMS system was designed based on the MIL-STD-461-F and the ECSS-E-ST-20--07C Rev.1 standards.
However, the exact conditions of the standards could not be achieved in a local laboratory, so the equivalent commercial-grade tests based on the IEC 61000 standard were conducted.

The most prominent result of the EMC test campaign was a non-compliant conducted emission at around 2.2 MHz, as shown in \autoref{fig:emc-CE-100k-30M}.
After analysis, this emission along with the length of the untwisted portion of the power supply cables is believed to be the root cause behind the non-compliant radiated emissions depicted in \autoref{fig:emc-RE-30M-1G}.
The rest of the EMC tests were successful, with a clean emissions spectrum above 1 GHz, as shown in \autoref{fig:emc-RE-1G-12G} and no malfunctions on the conducted and radiated susceptibility tests.

By the closure of this activity, measures have been taken to mitigate the non-compliant conducted emissions, such as an EMI filter at the power input.
Moreover, an EMI shield has been added over the bottom layer in addition to one existing over the top layer.
These measures are to be tested with the next revision of the SatNOGS COMMS' hardware.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/emc-CE-100k-30M.png}
    \caption{Conducted Emissions test result: 100 kHz to 30 Mhz}\label{fig:emc-CE-100k-30M}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/emc-RE-30M-1G.png}
    \caption{Radiated Emissions test result: 30 MHz to 1 GHz}\label{fig:emc-RE-30M-1G}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/emc-RE-1G-12G.png}
    \caption{Radiated Emissions test result: 1 GHz to 12 GHz}\label{fig:emc-RE-1G-12G}
\end{figure}

\section{Curium--1 Mission}

Perhaps one of the greatest highlights of the SatNOGS COMMS activity was the integration and in-orbit operation of the system abort the Curium-1 satellite.
This was a 12U CubeSat which was launched in the maiden flight of the Ariane 6 rocket in Summer 2024.
Unfortunately, the satellite did not fully deploy its antennas and initial transmissions from SatNOGS COMMS were inobservable.
However, the operators of the Dwingeloo Radio Observatory (\autoref{fig:dwingeloo}), to whom the SatNOGS COMMS team is thankful for their help, were kind enough to allocate some observation time for Curium-1.

This way, the very faint UHF signals depicted in \autoref{fig:waterfall-dwingeloo-curium-1} were detected and, despite the low signal-to-noise ratio, some key telemetry was recovered.
In particular, the temperatures on SatNOGS COMMS were nominal and the board had not experienced any resets up to some days after being initially powered on.

\begin{figure}[H]
    \centering
    \includegraphics[width=0.75\linewidth]{diagrams/dwingeloo.png}
    \caption{The Dwingeloo Radio Observatory}\label{fig:dwingeloo}
\end{figure}

\begin{figure}[H]
    \centering
    \includegraphics[width=0.5\linewidth]{diagrams/waterfall-curium-1-PI9CAM-V-10-07-2024.png}
    \caption{Waterfall display from an observation of Curium-1 from the Dwingeloo Radio Observatory}\label{fig:waterfall-dwingeloo-curium-1}
\end{figure}

\renewcommand\bibname{References}
\bibliographystyle{unsrt}
\bibliography{references}

\end{document}